aboutsummaryrefslogtreecommitdiff
path: root/libgo
diff options
context:
space:
mode:
authorIan Lance Taylor <ian@gcc.gnu.org>2011-12-13 22:25:30 +0000
committerIan Lance Taylor <ian@gcc.gnu.org>2011-12-13 22:25:30 +0000
commitc915f63f7324de03f233803667d6401088fec783 (patch)
treec0130cd10550a0fc877a4c24987f6877ba97484e /libgo
parentde05aad6833ce65a439fbeb2994df169112cba5e (diff)
downloadgcc-c915f63f7324de03f233803667d6401088fec783.zip
gcc-c915f63f7324de03f233803667d6401088fec783.tar.gz
gcc-c915f63f7324de03f233803667d6401088fec783.tar.bz2
mksysinfo.sh: Ensure that IPV6 constants and types are defined.
From-SVN: r182314
Diffstat (limited to 'libgo')
-rwxr-xr-xlibgo/mksysinfo.sh24
1 files changed, 17 insertions, 7 deletions
diff --git a/libgo/mksysinfo.sh b/libgo/mksysinfo.sh
index 6d8575c..a5e8144 100755
--- a/libgo/mksysinfo.sh
+++ b/libgo/mksysinfo.sh
@@ -183,10 +183,12 @@ grep '^const _SOMAXCONN' gen-sysinfo.go |
grep '^const _SHUT_' gen-sysinfo.go |
sed -e 's/^\(const \)_\(SHUT[^= ]*\)\(.*\)$/\1\2 = _\2/' >> ${OUT}
-# The net package requires a definition for IPV6ONLY.
-if ! grep '^const IPV6_V6ONLY ' ${OUT} >/dev/null 2>&1; then
- echo "const IPV6_V6ONLY = 0" >> ${OUT}
-fi
+# The net package requires some const definitions.
+for m in IPV6_V6ONLY IPPROTO_IPV6 IPV6_JOIN_GROUP IPV6_LEAVE_GROUP; do
+ if ! grep "^const $m " ${OUT} >/dev/null 2>&1; then
+ echo "const $m = 0" >> ${OUT}
+ fi
+done
# pathconf constants.
grep '^const __PC' gen-sysinfo.go |
@@ -474,11 +476,14 @@ grep '^type _ip_mreq ' gen-sysinfo.go | \
-e 's/_in_addr/[4]byte/g' \
>> ${OUT}
-# The size of the ip_mreq struct.
-if grep 'type IPMreq ' ${OUT} > /dev/null 2>&1; then
- echo 'var SizeofIPMreq = int(unsafe.Sizeof(IPMreq{}))' >> ${OUT}
+# We need IPMreq to compile the net package.
+if ! grep 'type IPMreq ' ${OUT} >/dev/null 2>&1; then
+ echo 'type IPMreq struct { Multiaddr [4]byte; Interface [4]byte; }' >> ${OUT}
fi
+# The size of the ip_mreq struct.
+echo 'var SizeofIPMreq = int(unsafe.Sizeof(IPMreq{}))' >> ${OUT}
+
# The ipv6_mreq struct.
grep '^type _ipv6_mreq ' gen-sysinfo.go | \
sed -e 's/_ipv6_mreq/IPv6Mreq/' \
@@ -487,6 +492,11 @@ grep '^type _ipv6_mreq ' gen-sysinfo.go | \
-e 's/_in6_addr/[16]byte/' \
>> ${OUT}
+# We need IPv6Mreq to compile the net package.
+if ! grep 'type IPv6Mreq ' ${OUT} >/dev/null 2>&1; then
+ echo 'type IPv6Mreq struct { Multiaddr [16]byte; Interface uint32; }' >> ${OUT}
+fi
+
# Try to guess the type to use for fd_set.
fd_set=`grep '^type _fd_set ' gen-sysinfo.go || true`
fds_bits_type="_C_long"